"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PayControllers = void 0;
const listService_1 = require("../services/pay/listService");
const approval_1 = require("../services/pay/approval");
class PayControllers {
    list(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const listPayService = new listService_1.ListPayService();
            const listPayServiceExec = yield listPayService.execute(request.user_cod, '', request.database);
            return response.status(listPayServiceExec.status).json(listPayServiceExec.message);
        });
    }
    listForn(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { fornCod } = request.params;
            const queryString = `
      AND
        FORN_COD = ${fornCod}
    `;
            const listPayService = new listService_1.ListPayService();
            const listPayServiceExec = yield listPayService.execute(request.user_cod, queryString, request.database);
            return response.status(listPayServiceExec.status).json(listPayServiceExec.message);
        });
    }
    listCere(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { cereCod } = request.params;
            const queryString = `
      AND
        CERE_COD = ${cereCod}
    `;
            const listPayService = new listService_1.ListPayService();
            const listPayServiceExec = yield listPayService.execute(request.user_cod, queryString, request.database);
            return response.status(listPayServiceExec.status).json(listPayServiceExec.message);
        });
    }
    listNum(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const listPayService = new listService_1.ListPayService();
            const { trpgCod } = request.params;
            const queryString = `
      AND
        TRPG_COD = ${trpgCod}
    `;
            const listPayServiceExec = yield listPayService.execute(request.user_cod, queryString, request.database);
            return response.status(listPayServiceExec.status).json(listPayServiceExec.message);
        });
    }
    listNumDoc(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const listPayService = new listService_1.ListPayService();
            const { trpgNumDoc } = request.params;
            const queryString = `
      AND
        TRPG_NUM_DOC = '${trpgNumDoc}'
    `;
            const listPayServiceExec = yield listPayService.execute(request.user_cod, queryString, request.database);
            return response.status(listPayServiceExec.status).json(listPayServiceExec.message);
        });
    }
    listPeriod(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const listPayService = new listService_1.ListPayService();
            const { dtIni, dtEnd } = request.params;
            const queryString = `
      AND
        trpp_dtvenc >= '${dtIni}'
      AND 
        trpp_dtvenc <= '${dtEnd}'
    `;
            const listPayServiceExec = yield listPayService.execute(request.user_cod, queryString, request.database);
            return response.status(listPayServiceExec.status).json(listPayServiceExec.message);
        });
    }
    approval(request, response) {
        var _a, e_1, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            const approvalPayService = new approval_1.ApprovalPayService();
            const { password, arrayPay } = request.body;
            let status = 200;
            const message = [];
            try {
                for (var _d = true, arrayPay_1 = __asyncValues(arrayPay), arrayPay_1_1; arrayPay_1_1 = yield arrayPay_1.next(), _a = arrayPay_1_1.done, !_a;) {
                    _c = arrayPay_1_1.value;
                    _d = false;
                    try {
                        const item = _c;
                        const approvalPayServiceExec = yield approvalPayService.execute(request.user_sigla, item.trppCod, item.cereCod, item.valor, password, request.database);
                        message.push(approvalPayServiceExec.message);
                        if (approvalPayServiceExec.error === true) {
                            status = 400;
                        }
                    }
                    finally {
                        _d = true;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = arrayPay_1.return)) yield _b.call(arrayPay_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return response.status(status).json(message);
        });
    }
}
exports.PayControllers = PayControllers;
