"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServiceContract = void 0;
const listServiceContractServices_1 = require("../services/serviceContract/listServiceContractServices");
const approvalServiceContract_1 = require("../services/serviceContract/approvalServiceContract");
const listDetailsService_1 = require("../services/serviceContract/listDetailsService");
class ServiceContract {
    list(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const listServiceContractServices = new listServiceContractServices_1.ListServiceContractServices();
            const execute = yield listServiceContractServices.execute(request.user_cod, '', request.database);
            return response.status(execute.status).json(execute.message);
        });
    }
    listCode(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { cod } = request.params;
            const queryString = `
    AND
      COCS_COD = ${cod}
    `;
            const listServiceContractServices = new listServiceContractServices_1.ListServiceContractServices();
            const execute = yield listServiceContractServices.execute(request.user_cod, queryString, request.database);
            return response.status(execute.status).json(execute.message);
        });
    }
    listEmpr(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { empr } = request.params;
            const queryString = `
    AND
      EMPR_NOME LIKE '%${empr}%'
    `;
            const listServiceContractServices = new listServiceContractServices_1.ListServiceContractServices();
            const execute = yield listServiceContractServices.execute(request.user_cod, queryString, request.database);
            return response.status(execute.status).json(execute.message);
        });
    }
    listFili(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { fili } = request.params;
            const queryString = `
    AND
      FILI_NOME_FANTASIA LIKE '%${fili}%'
    `;
            const listServiceContractServices = new listServiceContractServices_1.ListServiceContractServices();
            const execute = yield listServiceContractServices.execute(request.user_cod, queryString, request.database);
            return response.status(execute.status).json(execute.message);
        });
    }
    listForn(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { forn } = request.params;
            const queryString = `
    AND
      FORN_NOME LIKE '%${forn}%'
    `;
            const listServiceContractServices = new listServiceContractServices_1.ListServiceContractServices();
            const execute = yield listServiceContractServices.execute(request.user_cod, queryString, request.database);
            return response.status(execute.status).json(execute.message);
        });
    }
    listCereCod(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { cereCod } = request.params;
            const queryString = `
    AND
    COCS_FORN_COD = ${cereCod}
    `;
            const listServiceContractServices = new listServiceContractServices_1.ListServiceContractServices();
            const execute = yield listServiceContractServices.execute(request.user_cod, queryString, request.database);
            return response.status(execute.status).json(execute.message);
        });
    }
    listLocal(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { local } = request.params;
            const queryString = `
    AND
      LOCA_COD = ${local}
    `;
            const listServiceContractServices = new listServiceContractServices_1.ListServiceContractServices();
            console.log('====================================');
            console.log(queryString);
            console.log('====================================');
            const execute = yield listServiceContractServices.execute(request.user_cod, queryString, request.database);
            return response.status(execute.status).json(execute.message);
        });
    }
    listDetails(request, response) {
        return __awaiter(this, void 0, void 0, function* () {
            const { cod } = request.params;
            const listDetailsServiceContract = new listDetailsService_1.ListDetailsServiceContract();
            const execute = yield listDetailsServiceContract.execute(cod, request.database);
            return response.status(execute.status).json(execute.message);
        });
    }
    approval(request, response) {
        var _a, e_1, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            const { password, arrayCocs } = request.body;
            const approvalServiceContract = new approvalServiceContract_1.ApprovalServiceContract();
            const msgCocs = [];
            let status = 200;
            try {
                for (var _d = true, arrayCocs_1 = __asyncValues(arrayCocs), arrayCocs_1_1; arrayCocs_1_1 = yield arrayCocs_1.next(), _a = arrayCocs_1_1.done, !_a;) {
                    _c = arrayCocs_1_1.value;
                    _d = false;
                    try {
                        const item = _c;
                        console.log('====================================');
                        console.log(item);
                        console.log('====================================');
                        const execute = yield approvalServiceContract.execute(request.user_sigla, item.posAss + '', item.cod + '', password, item.valor, request.database);
                        if (execute.erro === true) {
                            status = execute.status;
                        }
                        msgCocs.push(execute.message);
                    }
                    finally {
                        _d = true;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = arrayCocs_1.return)) yield _b.call(arrayCocs_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return response.status(status).json(msgCocs);
        });
    }
}
exports.ServiceContract = ServiceContract;
