"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsonwebtoken_1 = __importDefault(require("jsonwebtoken"));
const dotenv_1 = __importDefault(require("dotenv"));
const isAuthenticated = (request, response, next) => {
    const authHeader = request.headers.authorization;
    dotenv_1.default.config();
    const secret = process.env.TOKEN_SECRET_REFRESH + '';
    if (!authHeader) {
        return response.status(400).json({ message: 'TOKEN IS MISSING' });
    }
    const [, token] = authHeader.split(' ');
    try {
        const { USUA_SIGLA, USUA_COD, DATABASE } = jsonwebtoken_1.default.verify(token, secret);
        request.user_cod = USUA_COD;
        request.user_sigla = USUA_SIGLA;
        request.database = DATABASE;
        console.log(request.database, request.user_sigla, request.user_cod);
        return next();
    }
    catch (_a) {
        return response.status(400).json({ message: 'TOKEN IS INVALID' });
    }
};
exports.default = isAuthenticated;
