"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.selectMovimentDetailsData = exports.selectMovimentDetailsDataAndApl = exports.selectMovimentFilterDataAndApl = exports.selectMovimentFilterData = exports.selectComboAplicacao = exports.selectMovimentacaoAplicacao = exports.selectMovimentacao = void 0;
const pega1Mes_1 = __importDefault(require("../../utils/pega1Mes"));
const pegaDataAtual_1 = __importDefault(require("../../utils/pegaDataAtual"));
const dataAt = (0, pegaDataAtual_1.default)();
const dataMesAtras = (0, pega1Mes_1.default)();
const selectMovimentacao = (cod, database) => {
    return `
    USE [${database}]
    SELECT
            SUM(MODI_DEBITO) AS DEBITO,
            gaco_nome,
            SUM(MODI_CREDITO) AS CREDITO,
            SUM(MODI_SALDO_ANTES) AS SALDO,
            MODI_DATA AS DATA
          FROM
            USUARIO
          INNER JOIN
            REL_USUARIO_SUBCONTA
          ON
            REUS_USUA_COD = USUA_COD
          INNER JOIN
            SUB_CONTA_CORRENTE
          ON
            SUCC_COD = REUS_SUCC_COD
          INNER JOIN
            MOVIMENTO_DIARIO
          ON
            MODI_SUCC_COD = SUCC_COD
          INNER JOIN
            ALOCACAO_CONTA
          ON
            ALCO_SUCC_COD = SUCC_COD
          INNER JOIN
            GRUPO_ALOC_CONTA
          ON
            ALCO_GACO_COD = GACO_COD
          INNER JOIN
            APLICACAO_CONTA
          ON
            APCO_COD = ALCO_APCO_COD
          WHERE
            USUA_COD = ${cod} 
          AND
            MODI_DATA
          BETWEEN
            '${dataMesAtras}' 
          AND
            '${dataAt}'
          GROUP BY 
            MODI_DATA,
            GACO_NOME 
          ORDER BY 
            MODI_DATA 
          DESC
  `;
};
exports.selectMovimentacao = selectMovimentacao;
const selectMovimentacaoAplicacao = (cod, aplicacao, database) => {
    return `
    USE [${database}]
    SELECT
            SUM(MODI_DEBITO) AS DEBITO,
            gaco_nome,
            SUM(MODI_CREDITO) AS CREDITO,
            SUM(MODI_SALDO_ANTES) AS SALDO,
            MODI_DATA AS DATA
          FROM
            USUARIO
          INNER JOIN
            REL_USUARIO_SUBCONTA
          ON
            REUS_USUA_COD = USUA_COD
          INNER JOIN
            SUB_CONTA_CORRENTE
          ON
            SUCC_COD = REUS_SUCC_COD
          INNER JOIN
            MOVIMENTO_DIARIO
          ON
            MODI_SUCC_COD = SUCC_COD
          INNER JOIN
            ALOCACAO_CONTA
          ON
            ALCO_SUCC_COD = SUCC_COD
          INNER JOIN
            GRUPO_ALOC_CONTA
          ON
            ALCO_GACO_COD = GACO_COD
          INNER JOIN
            APLICACAO_CONTA
          ON
            APCO_COD = ALCO_APCO_COD
          WHERE
            USUA_COD = ${cod} 
          AND
            GACO_NOME LIKE '%${aplicacao}%'
          AND
            MODI_DATA
          BETWEEN
            '${dataMesAtras}' 
          AND
            '${dataAt}'
          GROUP BY
            MODI_DATA,
            GACO_NOME
          ORDER BY
            MODI_DATA
          DESC
  `;
};
exports.selectMovimentacaoAplicacao = selectMovimentacaoAplicacao;
const selectComboAplicacao = (cod, database) => {
    return `
    USE [${database}]  
    SELECT
            DISTINCT(gaco_nome)
          FROM
            USUARIO
          INNER JOIN
            REL_USUARIO_SUBCONTA
          ON
            REUS_USUA_COD = USUA_COD
          INNER JOIN
            SUB_CONTA_CORRENTE
          ON
            SUCC_COD = REUS_SUCC_COD
          INNER JOIN
            MOVIMENTO_DIARIO
          ON
            MODI_SUCC_COD = SUCC_COD
          INNER JOIN
            ALOCACAO_CONTA
          ON
            ALCO_SUCC_COD = SUCC_COD
          INNER JOIN
            GRUPO_ALOC_CONTA
          ON
            ALCO_GACO_COD = GACO_COD
          INNER JOIN
            APLICACAO_CONTA
          ON
            APCO_COD = ALCO_APCO_COD
          INNER JOIN
            CONTA_CORRENTE
          ON
            SUCC_COCO_COD = COCO_COD
          WHERE
            USUA_CPD = ${cod}
  `;
};
exports.selectComboAplicacao = selectComboAplicacao;
const selectMovimentFilterData = (cod, dataIni, dataFim, database) => {
    return `
    USE [${database}]
    SELECT
            APCO_NOME,
            MODI_DEBITO,
            MODI_CREDITO,
            MODI_SALDO_ANTES,
            MODI_DATA,
            SUCC_DESC
          FROM
            USUARIO
          INNER JOIN
            REL_USUARIO_SUBCONTA
          ON
            REUS_USUA_COD = USUA_COD
          INNER JOIN
            SUB_CONTA_CORRENTE
          ON
            SUCC_COD = REUS_SUCC_COD
          INNER JOIN
            MOVIMENTO_DIARIO
          ON
            MODI_SUCC_COD = SUCC_COD
          INNER JOIN
            ALOCACAO_CONTA
          ON
            ALCO_SUCC_COD = SUCC_COD
          INNER JOIN
            GRUPO_ALOC_CONTA
          ON
            ALCO_GACO_COD = GACO_COD
          INNER JOIN
            APLICACAO_CONTA
          ON
            APCO_COD = ALCO_APCO_COD
          WHERE
            USUA_COD = ${cod} 
          AND
            MODI_DATA
          BETWEEN
            '${dataIni}' 
          AND
            '${dataFim}'
          `;
};
exports.selectMovimentFilterData = selectMovimentFilterData;
const selectMovimentFilterDataAndApl = (cod, dataIni, dataFim, aplicacao, database) => {
    return `
    USE [${database}]
    SELECT
            APCO_NOME,
            MODI_DEBITO,
            MODI_CREDITO,
            MODI_SALDO_ANTES,
            MODI_DATA,
            SUCC_DESC
          FROM
            USUARIO
          INNER JOIN
            REL_USUARIO_SUBCONTA
          ON
            REUS_USUA_COD = USUA_COD
          INNER JOIN
            SUB_CONTA_CORRENTE
          ON
            SUCC_COD = REUS_SUCC_COD
          INNER JOIN
            MOVIMENTO_DIARIO
          ON
            MODI_SUCC_COD = SUCC_COD
          INNER JOIN
            ALOCACAO_CONTA
          ON
            ALCO_SUCC_COD = SUCC_COD
          INNER JOIN
            GRUPO_ALOC_CONTA
          ON
            ALCO_GACO_COD = GACO_COD
          INNER JOIN
            APLICACAO_CONTA
          ON
            APCO_COD = ALCO_APCO_COD
          WHERE
            USUA_COD = ${cod}
          AND
            MODI_DATA
          BETWEEN
            '${dataIni}' 
          AND
            '${dataFim}'
          AND 
            GACO_NOME LIKE'%${aplicacao}%'
          `;
};
exports.selectMovimentFilterDataAndApl = selectMovimentFilterDataAndApl;
const selectMovimentDetailsDataAndApl = (cod, data, aplicacao, database) => {
    return `
    USE [${database}]
    SELECT 
            APCO_NOME,
            MODI_DEBITO,
            MODI_CREDITO,
            MODI_SALDO_ANTES,
            MODI_DATA,
            SUCC_DESC
          FROM
            USUARIO
          INNER JOIN
            REL_USUARIO_SUBCONTA
          ON
            REUS_USUA_COD = USUA_COD
          INNER JOIN
            SUB_CONTA_CORRENTE
          ON
            SUCC_COD = REUS_SUCC_COD
          INNER JOIN
            MOVIMENTO_DIARIO
          ON
            MODI_SUCC_COD = SUCC_COD
          INNER JOIN
            ALOCACAO_CONTA
          ON
            ALCO_SUCC_COD = SUCC_COD
          INNER JOIN
            GRUPO_ALOC_CONTA
          ON
            ALCO_GACO_COD = GACO_COD
          INNER JOIN
            APLICACAO_CONTA
          ON
            APCO_COD = ALCO_APCO_COD
          WHERE
            USUA_COD = ${cod} 
          AND
            MODI_DATA = '${data}'
          AND 
            gaco_nome LIKE'%${aplicacao}%'
          `;
};
exports.selectMovimentDetailsDataAndApl = selectMovimentDetailsDataAndApl;
const selectMovimentDetailsData = (cod, data, database) => {
    return `
    USE [${database}]
    SELECT 
      APCO_NOME,
      MODI_DEBITO,
      MODI_CREDITO,
      MODI_SALDO_ANTES,
      MODI_DATA,
      SUCC_DESC
    FROM
      USUARIO
    INNER JOIN
      REL_USUARIO_SUBCONTA
    ON
      REUS_USUA_COD = USUA_COD
    INNER JOIN
      SUB_CONTA_CORRENTE
    ON
      SUCC_COD = REUS_SUCC_COD
    INNER JOIN
      MOVIMENTO_DIARIO
    ON
      MODI_SUCC_COD = SUCC_COD
    INNER JOIN
      ALOCACAO_CONTA
    ON
      ALCO_SUCC_COD = SUCC_COD
    INNER JOIN
      GRUPO_ALOC_CONTA
    ON
      ALCO_GACO_COD = GACO_COD
    INNER JOIN
      APLICACAO_CONTA
    ON
      APCO_COD = ALCO_APCO_COD
    WHERE
      USUA_COD = ${cod} 
    AND
      MODI_DATA = '${data}'
`;
};
exports.selectMovimentDetailsData = selectMovimentDetailsData;
