"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable @typescript-eslint/no-unused-vars */
require("reflect-metadata");
require("express-async-errors");
const express_1 = __importDefault(require("express"));
const cors_1 = __importDefault(require("cors"));
const index_1 = require("./typeorm/index");
const AppError_1 = __importDefault(require("./errors/AppError"));
const dotenv_1 = __importDefault(require("dotenv"));
const index_routes_1 = require("./routes/v1/index.routes");
dotenv_1.default.config();
index_1.AppDataSource.initialize().then(() => {
    const app = (0, express_1.default)();
    app.use((0, cors_1.default)());
    app.use(express_1.default.json());
    app.use((error, req, res, next) => {
        if (error instanceof AppError_1.default) {
            return res.status(error.statusCode).json({
                error: error.message,
                status: error.statusCode
            });
        }
        return res.status(500).json({
            status: 'error',
            message: 'Internal server'
        });
    });
    app.use('/v1', index_routes_1.routerV1);
    const port = process.env.PORT;
    app.listen(port, () => {
        console.log(`RODANDO NA PORTA ${port}`);
    });
});
