"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DetailsMoivmentService = void 0;
const movimentoDiarioRepositories_1 = require("../../typeorm/repository/movimentoDiarioRepositories");
const movDiaria_1 = require("../../queries/movDiaria");
class DetailsMoivmentService {
    execute(cod, data, aplicacao, database) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                if (aplicacao === '') {
                    const sql = (0, movDiaria_1.selectMovimentDetailsData)(cod, data, database);
                    const movimentQuery = yield movimentoDiarioRepositories_1.MovimentoDiarioRepository.query(sql);
                    return movimentQuery;
                }
                const sql = (0, movDiaria_1.selectMovimentDetailsDataAndApl)(cod, data, aplicacao, database);
                const movimentQuery = yield movimentoDiarioRepositories_1.MovimentoDiarioRepository.query(sql);
                return {
                    message: movimentQuery,
                    status: 200
                };
            }
            catch (err) {
                return {
                    message: 'Internal Server Error',
                    status: 500
                };
            }
        });
    }
}
exports.DetailsMoivmentService = DetailsMoivmentService;
