"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListItemPgcService = void 0;
const usuarioRepositories_1 = require("../../typeorm/repository/usuarioRepositories");
const itemPcg_1 = require("../../queries/itemPcg");
const userRc_1 = require("../../queries/userRc");
class ListItemPgcService {
    execute(cod, plgcCod, trcrCod, cereCod, database) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const selectNiacCod = (0, userRc_1.selectLevelRcUser)(cereCod, cod, database);
                const niacCodQuery = yield usuarioRepositories_1.UsuarioRepository.query(selectNiacCod);
                let niacCod = '0';
                if (niacCodQuery[0]) {
                    niacCod = niacCodQuery[0].USCR_NIAC_COD_PG;
                }
                const selectForPlgcQuery = (0, itemPcg_1.selectForPlgc)(niacCod, trcrCod, plgcCod, database);
                const itemsPcg = yield usuarioRepositories_1.UsuarioRepository.query(selectForPlgcQuery);
                return {
                    error: false,
                    message: itemsPcg,
                    status: 200
                };
            }
            catch (error) {
                return {
                    error: true,
                    message: 'Internal Server Error',
                    status: 500
                };
            }
        });
    }
}
exports.ListItemPgcService = ListItemPgcService;
