"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApprovalPlac = void 0;
const purchaseWorksheet_1 = require("../../queries/purchaseWorksheet");
const usuarioRepositories_1 = require("../../typeorm/repository/usuarioRepositories");
const verifyUser_1 = require("../../utils/verifyUser");
class ApprovalPlac {
    execute(sigla, placCod, password, pos, database) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const { error, message, status } = yield (0, verifyUser_1.verifyUserApproval)(sigla, password, database);
                if (error) {
                    return ({
                        message,
                        error,
                        status
                    });
                }
                const sqlCount = (0, purchaseWorksheet_1.countNumAprovaPlacCompra)(placCod, database);
                const resultCount = yield usuarioRepositories_1.UsuarioRepository.query(sqlCount);
                const resultPage = yield usuarioRepositories_1.UsuarioRepository.query(`
        USE [${database}]
        SELECT 
            page_num_aprovacoes_solic,
            page_todas_aprovacoes_solic
        FROM 
            PARAMETROS_GERAIS
      `);
                let statusSql = '';
                if (resultPage[0].page_todas_aprovacoes_solic === 'S') {
                    if (resultPage[0].page_num_aprovacoes_solic === 1) {
                        statusSql = "PLAC_STATUS = 'P',";
                    }
                    else if (resultPage[0].page_num_aprovacoes_solic === 2 && resultCount[0].NUM === 1) {
                        statusSql = "PLAC_STATUS = 'P',";
                    }
                }
                else {
                    statusSql = "PLAC_STATUS = 'P',";
                }
                const sqlApproval = (0, purchaseWorksheet_1.updateAssPlac)(placCod, pos, statusSql, database);
                yield usuarioRepositories_1.UsuarioRepository.query(sqlApproval);
                return {
                    message: `Planilha ${placCod} aprovada com sucesso`,
                    status: 200,
                    error: false
                };
            }
            catch (e) {
                return ({
                    message: `Erro na planilha ${placCod}  ${e}`,
                    error: true,
                    status: 500
                });
            }
        });
    }
}
exports.ApprovalPlac = ApprovalPlac;
