"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreatePurchase = void 0;
// SOCO_DEBITO_DIRETO
const usuarioRepositories_1 = require("../../typeorm/repository/usuarioRepositories");
const purchaseOrder_1 = require("../../queries/purchaseOrder");
class CreatePurchase {
    execute({ secoCod, servCod, itpcRateioCod, cereCod, unmaCod, almoCod, dtNece, qtd, mateCod, pessCodSoli, ass1, ass2, cod, database, itpcCod, debitoDireto }) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const dt = new Date();
                let data;
                dt.getDate() > 10 ? data = dt.getDate() : data = '0' + dt.getDate();
                let month = dt.getMonth() + 1;
                month < 10 ? month = '0' + (dt.getMonth() + 1) : month = dt.getMonth() + 1;
                const dtSoli = dt.getFullYear() + '-' + month + '-' + data;
                const sqlSocoCodMax1 = `
      USE [${database}]
      SELECT 
        MAX(SOCO_COD) + 1 as COD
      FROM 
        SOLICITACAO_COMPRA
      `;
                const dataSocoCodMax1 = yield usuarioRepositories_1.UsuarioRepository.query(sqlSocoCodMax1);
                const socoCod = dataSocoCodMax1[0].COD;
                const socoCodUltimo = socoCod - 1;
                const sqlSocoNum = `
      USE [${database}]
        SELECT
          (ISNULL(SOCO_NUMERO,0) + 1) AS SOCO_NUMERO
        FROM
          SOLICITACAO_COMPRA
        WHERE
          SOCO_COD = ${socoCodUltimo}
      `;
                const dataSocoNumMax1 = yield usuarioRepositories_1.UsuarioRepository.query(sqlSocoNum);
                const socoNum = dataSocoNumMax1[0].SOCO_NUMERO;
                console.log('====================================');
                console.log({
                    socoCod,
                    itpcRateioCod,
                    servCod,
                    userLogged: cod + '',
                    cereCod,
                    secoCod,
                    unmaCod,
                    almoCod,
                    dtSoli,
                    dtNece,
                    qtd,
                    mateCod,
                    socoNum,
                    pessCodSoli,
                    ass1,
                    ass2,
                    database,
                    itpcCod,
                    debitoDireto
                });
                console.log('====================================');
                const sqlInsertSoco = (0, purchaseOrder_1.insertSoco)({
                    socoCod,
                    itpcRateioCod,
                    servCod,
                    userLogged: cod + '',
                    cereCod,
                    secoCod,
                    unmaCod,
                    almoCod,
                    dtSoli,
                    dtNece,
                    qtd,
                    mateCod,
                    socoNum,
                    pessCodSoli,
                    ass1,
                    ass2,
                    database,
                    itpcCod,
                    debitoDireto
                });
                console.log('====================================');
                console.log(sqlInsertSoco);
                console.log('====================================');
                yield usuarioRepositories_1.UsuarioRepository.query(sqlInsertSoco);
                return ({
                    message: `Solicitação ${socoCod} inserida com sucesso`,
                    status: 200,
                    error: false
                });
            }
            catch (e) {
                return ({
                    message: 'Intertanl server error ' + e,
                    status: 500,
                    error: true
                });
            }
        });
    }
}
exports.CreatePurchase = CreatePurchase;
