"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListScheduleService = void 0;
const schedule_1 = require("../../queries/schedule");
const pedidoEstoqueRepositories_1 = require("../../typeorm/repository/pedidoEstoqueRepositories");
class ListScheduleService {
    execute(database) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const sqlSelectPefiPejuPess = (0, schedule_1.selectPefiPejuPess)(database);
                const listPefiPejuPess = yield pedidoEstoqueRepositories_1.PedidoEstoqueRepository.query(sqlSelectPefiPejuPess);
                return {
                    message: listPefiPejuPess,
                    status: 200
                };
            }
            catch (_a) {
                return {
                    message: 'Internal server error',
                    status: 500
                };
            }
        });
    }
}
exports.ListScheduleService = ListScheduleService;
